package com.googlecode.eventio.core;



/**
 * Low level resource, i.e. resource that may block the calling thread. A {@link BlockingResource} can be converted to a {@link Resource} by
 * having it managed by a {@link ResourceAccessManager}.
 * 
 * @author mofleury
 * 
 * @param <INPUT>
 * @param <OUTPUT>
 * 
 * @see Resource
 * @see ResourceAccessManager
 */
public interface BlockingResource<INPUT, OUTPUT> {

	public OUTPUT doGet(INPUT input);
}
