package com.googlecode.eventio.core.impl;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

public final class CompositeEvent {

	private final Map<String, Object> subEvents;

	public Map<String, Object> getSubEvents() {
		return subEvents;
	}

	public static class Builder {
		private Map<String, Object> subEvents = new HashMap<String, Object>();

		public Builder event(String key, Object event) {
			subEvents.put(key, event);
			return this;
		}

		public CompositeEvent build() {
			return new CompositeEvent(this);
		}
	}

	private CompositeEvent(Builder builder) {
		this.subEvents = Collections.unmodifiableMap(new HashMap<String, Object>(builder.subEvents));
	}

	@Override
	public String toString() {
		return "CompositeEvent [subEvents=" + subEvents + "]";
	}

}
