package com.googlecode.eventio.core.impl.util;

import java.util.Collection;
import java.util.Deque;
import java.util.Iterator;
import java.util.NoSuchElementException;

public class EmptyDeque<T> implements Deque<T> {

	@SuppressWarnings("rawtypes")
	public static final Deque EMPTY_DEQUE = new EmptyDeque();

	@SuppressWarnings("unchecked")
	public static <T> Deque<T> emptyDeque() {
		return EMPTY_DEQUE;
	}

	private final Iterator<T> EMPTY_ITERATOR = new Iterator<T>() {
		@Override
		public boolean hasNext() {
			return false;
		}

		@Override
		public T next() {
			throw new UnsupportedOperationException();
		}

		@Override
		public void remove() {
			throw new UnsupportedOperationException();
		}
	};

	@Override
	public boolean addAll(Collection<? extends T> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void clear() {
		throw new UnsupportedOperationException();

	}

	@Override
	public boolean containsAll(Collection<?> c) {
		return false;
	}

	@Override
	public boolean isEmpty() {
		return true;
	}

	@Override
	public boolean removeAll(Collection<?> c) {
		return false;
	}

	@Override
	public boolean retainAll(Collection<?> c) {
		return false;
	}

	@Override
	public Object[] toArray() {
		final Object[] array = {};
		return array;
	}

	@Override
	public <T> T[] toArray(T[] a) {
		return a;
	}

	@Override
	public boolean add(T e) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void addFirst(T e) {
		throw new UnsupportedOperationException();

	}

	@Override
	public void addLast(T e) {
		throw new UnsupportedOperationException();

	}

	@Override
	public boolean contains(Object o) {
		return false;
	}

	@Override
	public Iterator<T> descendingIterator() {
		return EMPTY_ITERATOR;
	}

	@Override
	public T element() {
		throw new NoSuchElementException();
	}

	@Override
	public T getFirst() {
		return null;
	}

	@Override
	public T getLast() {
		return null;
	}

	@Override
	public Iterator<T> iterator() {
		return EMPTY_ITERATOR;
	}

	@Override
	public boolean offer(T e) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean offerFirst(T e) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean offerLast(T e) {
		throw new UnsupportedOperationException();
	}

	@Override
	public T peek() {
		return null;
	}

	@Override
	public T peekFirst() {
		return null;
	}

	@Override
	public T peekLast() {
		return null;
	}

	@Override
	public T poll() {
		return null;
	}

	@Override
	public T pollFirst() {
		return null;
	}

	@Override
	public T pollLast() {
		return null;
	}

	@Override
	public T pop() {
		throw new NoSuchElementException();
	}

	@Override
	public void push(T e) {
		throw new UnsupportedOperationException();

	}

	@Override
	public T remove() {
		throw new NoSuchElementException();
	}

	@Override
	public boolean remove(Object o) {
		return false;
	}

	@Override
	public T removeFirst() {
		throw new NoSuchElementException();
	}

	@Override
	public boolean removeFirstOccurrence(Object o) {
		return false;
	}

	@Override
	public T removeLast() {
		throw new NoSuchElementException();
	}

	@Override
	public boolean removeLastOccurrence(Object o) {
		return false;
	}

	@Override
	public int size() {
		return 0;
	}

}
