package com.googlecode.eventio.core.impl.util.monitoring;

import java.lang.management.ManagementFactory;
import java.util.concurrent.BlockingQueue;

import javax.management.MBeanException;
import javax.management.MBeanServer;
import javax.management.ObjectName;
import javax.management.OperationsException;

public class QueueMonitor implements QueueMonitorMBean {

	private final BlockingQueue<?> target;

	public QueueMonitor(BlockingQueue<?> target, String name) {
		super();
		this.target = target;

		MBeanServer mbs = ManagementFactory.getPlatformMBeanServer();
		ObjectName objectName;
		try {
			objectName = new ObjectName("com.googlecode.eventio.queue:name=" + name);
			mbs.registerMBean(this, objectName);
		} catch (OperationsException e) {
			throw new IllegalStateException("Unable to register MBean with name " + name, e);
		} catch (MBeanException e) {
			throw new IllegalStateException("Unable to register MBean with name " + name, e);
		}
	}

	public int getSize() {
		return target.size();
	}
}
